// Definitions for ITGraph Constants

// Definitions needed to call the Clear Method, as follows:
// <ITGraph Control>.SendMessage(VBM_METHOD, METH_CLEAR, 0L);
#ifndef VBM_METHOD
#define VBM_METHOD 0x1011
#endif
#ifndef METH_CLEAR
#define METH_CLEAR 0x000A
#endif

// ArrangeMode Settings
#define ITG_ModeHierarchy	0
#define ITG_ModeCompact		1
#define ITG_ModeFlowChart	2
#define ITG_ModeTree			3

// AutoArrange Settings
#define ITG_ManualArrange	0
#define ITG_AutoArrange		1
#define ITG_ArrangeNow		2

// AutoMouseEvent Mouse Buttons
#define ITG_LeftButton		0
#define ITG_MiddleButton	1
#define ITG_RightButton		2

// AutoMouseEvent Key Modifiers
#define ITG_ShiftDown		1
#define ITG_CtrlDown			2
#define ITG_AltDown			4

// AutoMouseEvent Action Flags
#define ITG_ameNone			0
#define ITG_ameMouseEvent	1
#define ITG_ameConnect		2
#define ITG_ameConstrained	4
#define ITG_ameDrag			8
#define ITG_ameSelect		16
#define ITG_ameResize		32

// ConnectionAlign Settings
#define ITG_AlignLeft		0
#define ITG_AlignCenter		1
#define ITG_AlignRight		2

// ConnectionArrow Settings
#define ITG_AHNone			0
#define ITG_AHSolid			1
#define ITG_AHHollow			2
#define ITG_AHOutline		3
#define ITG_AHSOlidCircle	4
#define ITG_AHHollowCircle	5

// DrawBackLings Settings
#define ITG_NoBackLinks			0
#define ITG_SolidBackLinks		1
#define ITG_DashedBackLinks	2

// DrawDir Settings
#define ITG_RightToLeft		0
#define ITG_LeftToRight		1
#define ITG_BottomToTop		2
#define ITG_TopToBottom		3

// GraphicAllowImport Settings
#define ITG_NoImportGraphics	0
#define ITG_ImportGraphics		1
#define ITG_ModifyDTGraphics	2
#define ITG_DeleteDTGraphics	3

// ItemShape Settings
#define ITG_ShapeNone				0
#define ITG_ShapeDefault			1
#define ITG_ShapeRectangle			1
#define ITG_ShapeEllipse			2
#define ITG_ShapeRoundRect			3
#define ITG_ShapeParallelogram1	4
#define ITG_ShapeParallelogram2	5
#define ITG_ShapeHexagon			6
#define ITG_ShapePage				7
#define ITG_ShapeDiamond			8
#define ITG_ShapeOctagon			9
#define ITG_ShapePapers1			10
#define ITG_ShapePapers2			11

// ItemGraphicAlign and ItemLabelAlign Settings
#define ITG_AlignTopLeft		0
#define ITG_AlignTopCenter		1
#define ITG_AlignTopRight		2
#define ITG_AlignMiddleLeft	3
#define ITG_AlignMiddleCenter	4
#define ITG_AlignMiddleRight	5
#define ITG_AlignBottomLeft	6
#define ITG_AlignBottomCenter	7
#define ITG_AlignBottomRight	8

// ItemGraphicStyle Settings
#define ITG_GraphicNone				0
#define ITG_GraphicIconFill		1
#define ITG_GraphicIconFillIso	2
#define ITG_GraphicShapeFill		3
#define ITG_GraphicShapeFillIso	4

// QueryState Settings
#define ITG_QueryNone						0
#define ITG_QueryGetSources				1
#define ITG_QueryGetTargets				2
#define ITG_QueryGetConnections			3
#define ITG_QueryGetSelectRectItems		4
#define ITG_QueryIterate					5
#define ITG_QueryMatchItemId				6
#define ITG_QueryMatchItemData			7
#define ITG_QueryMatchConnectionId		8
#define ITG_QueryMatchConnectionData	9

// RubberBand Settings
#define ITG_RBNone		0
#define ITG_RBItems		1
#define ITG_RBHandles	2
#define ITG_RBBoth		3

// StoreGraphics Settings
#define ITG_NoLoadGraphics		0
#define ITG_NoSaveGraphics		1
#define ITG_SaveUsedGraphics	2
#define ITG_SaveRTGraphics		3
#define ITG_SaveDTGraphics		4
